# The LearningOnline Network
# Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1 Gerd Kortemeyer
#
package Apache::lonlogin;

use strict;
use Apache::Constants qw(:common);
use Apache::File ();
use Apache::lonnet();

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

    my $iconpath= $r->dir_config('lonIconsURL');
    my $domain  = $r->dir_config('lonDefDomain');
    my $role    = $r->dir_config('lonRole');
    my $loadlim = $r->dir_config('lonLoadLim');
    my $servadm = $r->dir_config('lonAdmEMail');
    my $sysadm  = $r->dir_config('lonSysEMail');
    my $lonhost = $r->dir_config('lonHostID');
    my $tabdir  = $r->dir_config('lonTabDir');
    my $include = $r->dir_config('lonIncludes');

    my $loadavg;
   {
       my $loadfile=Apache::File->new('/proc/loadavg');
       $loadavg=<$loadfile>;
   }
    $loadavg =~ s/\s.*//g;
    my $loadpercent=100*$loadavg/$loadlim;

    my $otherserver='';
    my $firsturl=$ENV{'request.firsturl'};
# ---------------------------------------- Are we access server and overloaded?
    if (($role eq 'access') && ($loadpercent>100.0)) {
        $otherserver=Apache::lonnet::spareserver();
    }

# -------------------------------------------------------- Set login parameters

    my @hexstr=('0','1','2','3','4','5','6','7',
                '8','9','a','b','c','d','e','f');
    my $lkey='';
    for (0..7) {
        $lkey.=$hexstr[rand(15)];
    }

    my $ukey='';
    for (0..7) {
        $ukey.=$hexstr[rand(15)];
    }

    my $lextkey=hex($lkey);
    my $uextkey=hex($ukey);
    my $logtoken=Apache::lonnet::reply(
       'tmpput:'.$ukey.$lkey.'&'.$firsturl,
       $lonhost);

# --------------------------------------------------- Print login screen header
    $r->print(<<ENDHEADER);
<html>
<head>
<title>The LearningOnline Network with CAPA Login</title>
</head>
ENDHEADER
# ---------------------------------------------------- Serve out DES JavaScript
    {
	my $jsh=Apache::File->new($include."/londes.js");
        $r->print(<$jsh>);
    }
# ---------------------------------------------------------- Serve rest of page
    $r->print(<<ENDDOCUMENT);

<body bgcolor="#FFFFFF" onLoad="init();">

<script language="JavaScript">

    function send() {
	this.document.server.elements.uname.value
       =this.document.client.elements.uname.value;

        this.document.server.elements.udom.value
       =this.document.client.elements.udom.value;

        uextkey=this.document.client.elements.uextkey.value;
        lextkey=this.document.client.elements.lextkey.value;
        initkeys();

        this.document.server.elements.upass.value
	    =crypted(this.document.client.elements.upass.value);

        this.document.server.submit();
    }

</script>

<table width=600>
<tr><td><img src="$iconpath/lonlogo.gif"></td>
<td bgcolor="#DDDDDD">
<font size=+1><b>User Authentication</b></font><p>

 <form name="server" action="$otherserver/adm/authenticate" 
  method="post" target="_top">
  <input type=hidden name=logtoken value="$logtoken">
  <input type=hidden name=serverid value="$lonhost">
  <input type=hidden name=uname value="">
  <input type=hidden name=upass value="">
  <input type=hidden name=udom value="">
 </form>

 <form name="client">
 <table border=2 bgcolor="#BBBBBB">
 <tr><td>Username:</td><td><input type=text size=10 name=uname></td></tr>
 <tr><td>Password:</td><td><input type=password size=10 name=upass></td></tr>
 <tr><td>Domain:</td><td><input type=text size=10 value=$domain name=udom></td>
 </tr>
 <tr><td colspan=2><input type=button value=Login onClick="send();"></td></tr>
 </table>
 <input type=hidden name=lextkey value="$lextkey">
 <input type=hidden name=uextkey value="$uextkey">
 </form>

</td>
</tr><tr><td bgcolor="#DDDDDD">
<table border=1 bgcolor="#BBBBBB">
<tr><td><font size="-1"><b>Domain:</b></font></td>
    <td><font size="-1"><tt>$domain</tt></font></td>
    <td rowspan=3><font size="-1"><b>LON System Administration:</b><br>
                  <tt>$sysadm</tt><br>
                  <b>Server Administration:</b><br>
                  <tt>$servadm</tt></font></td></tr>
<tr><td><font size="-1"><b>Server:</b></font></td>
    <td><font size="-1"><tt>$lonhost ($role)</tt></font></td></tr>
<tr><td><font size="-1"><b>Load:</b></font></td>
    <td><font size="-1"><tt>$loadpercent</tt> percent</font></td></tr>
</table>
</td><td>
<table align=right><tr><td><font size="+1">
<b>L</b>aboratory&nbsp;for<br>
<b>I</b>nstructional<br>
<b>T</b>echnology&nbsp;in<br>
<b>E</b>ducation</td><td>
<img src="$iconpath/liteani.gif"></font></td></tr></table></td></tr></table>
</body>
</html>
ENDDOCUMENT
    return OK;
} 

1;
__END__
