# The LearningOnline Network with CAPA
# TeX Conversion Module
#
# 05/29/00,05/30 Gerd Kortemeyer

package Apache::lontexconvert;

use strict;
use tth;
use vars qw($errorstring);

# ====================================================================== Header

sub header {
  $errorstring='<h1>TeX Conversion Error Messages</h1>';
  if ($ENV{'browser.mathml'}) {
      &tth::ttminit();
      return '<?xml version="1.0"?>'
            .'<?xml-stylesheet type="text/css" href="/adm/MathML/mathml.css"?>'
            .'<!DOCTYPE html SYSTEM "/adm/MathML/mathml.dtd" '
            .'[<!ENTITY mathns "http://www.w3.org/1998/Math/MathML">]>'
            .'<html xmlns:math="http://www.w3.org/1998/Math/MathML" ' 
            .'xmlns="http://www.w3.org/TR/REC-html40">'
            .'<body bgcolor="#FFFFFF">'."\n";
  } else {
      &tth::tthinit();
      my $headerstring='<html>';
      if ($ENV{'browser.os'} eq 'mac') { 
         $headerstring.="<head>\n"
             .'<meta Content-Type="text/html; charset=x-mac-roman">'
	     ."\n</head>\n";
      }
      return $headerstring.'<body bgcolor="#FFFFFF">'."\n";
  }
}

# ================================================================== Conversion

sub converted {
    my $texstring=shift;
    my $xmlstring;
    if ($ENV{'browser.mathml'}) {
      $xmlstring=&tth::ttm($texstring);
      $xmlstring=~s/\<math\>/\<math xmlns=\"\&mathns\;\"\>/g;
      $xmlstring=~s/\<br\>/\<br\/\>/g;
      $xmlstring=~s/\<p\>/\<p\>\<\/p\>/g;
      $errorstring.='<hr/>'.&tth::ttmerror();
  } else {
      $xmlstring=&tth::tth($texstring);
      $errorstring.='<hr>'.&tth::ttherror();
  }
  return $xmlstring;
}

# ====================================================================== Footer

sub footer {
  my $xmlstring='';
  if ($ENV{'request.state'} eq 'construct') {
      $xmlstring.=$errorstring;
  }
# -------------------------------------------------------------------- End Body
  $xmlstring.='</body></html>';
  return $xmlstring;
}

1;
__END__







